LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;

LIBRARY work;
USE work.YOLO_pkg.ALL;

ENTITY L2_WROM IS
    PORT (
        clk: IN STD_LOGIC;
        weight : OUT STD_LOGIC_VECTOR(17 DOWNTO 0);
        address : IN unsigned(weightsbitsAddress(2)-1 DOWNTO 0));
END L2_WROM;

ARCHITECTURE RTL OF L2_WROM IS

    TYPE ROM_mem IS ARRAY (0 TO 255) OF STD_LOGIC_VECTOR(17 DOWNTO 0);

    --kernel2 & kernel1

    signal ROM_content : ROM_mem := 
    (0=>"111000000"&"111111110",
    1=>"000000111"&"100111100",
    2=>"001000111"&"111011000",
    3=>"111000111"&"111111000",
    4=>"111000111"&"111111101",
    5=>"111010001"&"000111111",
    6=>"000111000"&"010011010",
    7=>"111111000"&"101100000",
    8=>"111000000"&"111100100",
    9=>"110001011"&"010011010",
    10=>"111000111"&"000011010",
    11=>"001100100"&"010000010",
    12=>"110000111"&"000111111",
    13=>"000000010"&"010010010",
    14=>"000111000"&"000000010",
    15=>"111000110"&"111111101",
    16=>"000001111"&"000000001",
    17=>"111001000"&"000000000",
    18=>"001001111"&"111111111",
    19=>"110110111"&"000000000",
    20=>"101001101"&"000111011",
    21=>"111110011"&"001011011",
    22=>"101011000"&"110000000",
    23=>"101001001"&"001000001",
    24=>"000001111"&"111111011",
    25=>"111110111"&"111011011",
    26=>"001001001"&"101111111",
    27=>"111111111"&"110011101",
    28=>"111001000"&"000000000",
    29=>"001001001"&"011110011",
    30=>"000000001"&"110000000",
    31=>"110110110"&"000000000",
    32=>"110100111"&"000001111",
    33=>"000110110"&"000011011",
    34=>"011001000"&"101000000",
    35=>"111000100"&"101001110",
    36=>"000001011"&"000001011",
    37=>"010110000"&"100001110",
    38=>"000100000"&"101100000",
    39=>"000100110"&"100001011",
    40=>"111100011"&"000001011",
    41=>"000110100"&"100010001",
    42=>"000110110"&"000001111",
    43=>"000011010"&"000001011",
    44=>"000100010"&"110100100",
    45=>"110110110"&"001001011",
    46=>"100110000"&"110110100",
    47=>"000110110"&"100001001",
    48=>"111000000"&"110110011",
    49=>"000001111"&"001101100",
    50=>"111100000"&"100011001",
    51=>"000001111"&"110011001",
    52=>"000000000"&"011001001",
    53=>"101011111"&"001100111",
    54=>"100001011"&"000000000",
    55=>"111100000"&"100110011",
    56=>"111000000"&"100011001",
    57=>"001001110"&"111010000",
    58=>"000000100"&"011011001",
    59=>"110100011"&"100100010",
    60=>"000000111"&"001000111",
    61=>"101000001"&"001100001",
    62=>"111101111"&"100100110",
    63=>"000001111"&"111010010",
    64=>"111110000"&"100000111",
    65=>"000000111"&"111100000",
    66=>"000000111"&"001001111",
    67=>"000000111"&"001111100",
    68=>"110100010"&"000011111",
    69=>"110110000"&"111001001",
    70=>"000000000"&"100001001",
    71=>"111111110"&"111000000",
    72=>"111111000"&"101000001",
    73=>"001011011"&"110000001",
    74=>"110110100"&"010010000",
    75=>"110010000"&"100000001",
    76=>"110100000"&"000001111",
    77=>"010010010"&"110000000",
    78=>"000011111"&"111100000",
    79=>"100000000"&"101001001",
    80=>"000111111"&"001001111",
    81=>"110010100"&"010110110",
    82=>"111000000"&"111111011",
    83=>"111001000"&"111111011",
    84=>"111001001"&"000011101",
    85=>"001100111"&"001011011",
    86=>"001001100"&"000100000",
    87=>"000110111"&"101000101",
    88=>"000111111"&"110111001",
    89=>"001101110"&"110101010",
    90=>"111110111"&"110111010",
    91=>"001100111"&"000101100",
    92=>"111001000"&"000000100",
    93=>"101100110"&"111111110",
    94=>"000000100"&"111010000",
    95=>"001101000"&"111111110",
    96=>"000000101"&"110111010",
    97=>"000010010"&"101000001",
    98=>"111111111"&"011011011",
    99=>"000000000"&"011011010",
    100=>"000111011"&"111000101",
    101=>"111111000"&"111100011",
    102=>"110101101"&"000000000",
    103=>"111101011"&"100111100",
    104=>"111011111"&"000111001",
    105=>"101000001"&"000000000",
    106=>"010000000"&"111000000",
    107=>"111101000"&"000000000",
    108=>"111111111"&"110110000",
    109=>"101101101"&"101000001",
    110=>"100000111"&"010000011",
    111=>"000000000"&"110110000",
    112=>"100100100"&"000000001",
    113=>"000101001"&"111110000",
    114=>"111011011"&"000000000",
    115=>"001001111"&"000000000",
    116=>"001001010"&"000000010",
    117=>"101101101"&"101111110",
    118=>"000000011"&"000000010",
    119=>"110110110"&"111101111",
    120=>"110110110"&"111100111",
    121=>"110110100"&"100111010",
    122=>"101000101"&"111011010",
    123=>"100100100"&"100011010",
    124=>"001101001"&"111111111",
    125=>"111000111"&"111111110",
    126=>"011000001"&"111010101",
    127=>"100101110"&"000000001",
    128=>"011010101"&"110110000",
    129=>"010101001"&"111000000",
    130=>"111010110"&"110110000",
    131=>"001100100"&"000110010",
    132=>"010100100"&"101000000",
    133=>"011011110"&"111000000",
    134=>"001001100"&"000011111",
    135=>"101010010"&"000111001",
    136=>"011010101"&"111000000",
    137=>"101110010"&"010011001",
    138=>"010010101"&"111000000",
    139=>"110011101"&"001000001",
    140=>"100010001"&"000000111",
    141=>"100010100"&"110010000",
    142=>"101001010"&"000010110",
    143=>"110010010"&"110010011",
    144=>"011011001"&"101101111",
    145=>"100100110"&"000000000",
    146=>"100110111"&"000000000",
    147=>"100110110"&"001001000",
    148=>"000000100"&"000000010",
    149=>"101000111"&"110100000",
    150=>"000000000"&"000100000",
    151=>"011011001"&"100101111",
    152=>"011001101"&"000000001",
    153=>"000000100"&"101111101",
    154=>"001000110"&"101110110",
    155=>"100100111"&"011011111",
    156=>"100100110"&"111111111",
    157=>"111101100"&"101111110",
    158=>"111011111"&"111101101",
    159=>"001100100"&"111111000",
    160=>"001011111"&"011100001",
    161=>"110100100"&"110001110",
    162=>"111001000"&"001110100",
    163=>"111100100"&"011100101",
    164=>"110100110"&"110100001",
    165=>"100001011"&"000011100",
    166=>"100000001"&"000001010",
    167=>"001011011"&"001110100",
    168=>"001011011"&"011110001",
    169=>"000000001"&"000011100",
    170=>"111111110"&"110100011",
    171=>"001100101"&"011100001",
    172=>"110000000"&"100000011",
    173=>"101001101"&"001110001",
    174=>"100001001"&"101011100",
    175=>"101000010"&"011110101",
    176=>"011100111"&"000000000",
    177=>"100111100"&"111111111",
    178=>"110011001"&"000110000",
    179=>"100110001"&"111111111",
    180=>"100110011"&"110101111",
    181=>"101001110"&"000011110",
    182=>"101000100"&"010000111",
    183=>"011100110"&"000000000",
    184=>"001110011"&"000000000",
    185=>"000110001"&"100100010",
    186=>"000110001"&"000111110",
    187=>"110001110"&"011011011",
    188=>"011000001"&"111111111",
    189=>"111100011"&"000001000",
    190=>"110001110"&"111101001",
    191=>"001100011"&"111111010",
    192=>"011010011"&"111111101",
    193=>"100111100"&"000000000",
    194=>"000000001"&"000000000",
    195=>"111000111"&"010011011",
    196=>"010110000"&"111000000",
    197=>"011011011"&"001011011",
    198=>"001001001"&"001001000",
    199=>"011011011"&"000011000",
    200=>"001001001"&"011101100",
    201=>"001101101"&"111111110",
    202=>"100100100"&"111100100",
    203=>"000100000"&"111111111",
    204=>"100100100"&"011000111",
    205=>"111000111"&"011011010",
    206=>"110110110"&"111011011",
    207=>"001001001"&"011000100",
    208=>"000111101"&"010100110",
    209=>"111000000"&"100010010",
    210=>"111100000"&"100100001",
    211=>"000111111"&"110010011",
    212=>"100000000"&"101100010",
    213=>"111000111"&"111010100",
    214=>"101000000"&"011011010",
    215=>"000000010"&"010100101",
    216=>"000010010"&"101101010",
    217=>"001000000"&"100101010",
    218=>"101111111"&"101100010",
    219=>"100000000"&"010110101",
    220=>"111000100"&"101101001",
    221=>"101111111"&"010001000",
    222=>"111111111"&"010011101",
    223=>"111000111"&"101101101",
    224=>"101101100"&"100100100",
    225=>"011001001"&"011011011",
    226=>"100111100"&"101100100",
    227=>"000111101"&"011001001",
    228=>"100100100"&"000000001",
    229=>"011011011"&"101100111",
    230=>"000100100"&"001001000",
    231=>"101101101"&"110110100",
    232=>"101101101"&"100100100",
    233=>"000110011"&"111001111",
    234=>"111100100"&"110101111",
    235=>"001001001"&"000000000",
    236=>"001111101"&"001001001",
    237=>"101101101"&"111111101",
    238=>"100100110"&"011101111",
    239=>"000011101"&"001001001",
    240=>"101111111"&"011001001",
    241=>"011011111"&"111001000",
    242=>"000011011"&"100101100",
    243=>"000011011"&"000101001",
    244=>"100000000"&"100000110",
    245=>"111101011"&"111001000",
    246=>"111100101"&"000000000",
    247=>"000111100"&"011001000",
    248=>"001011011"&"001001000",
    249=>"101000000"&"011001000",
    250=>"000000001"&"101111000",
    251=>"110010000"&"011001000",
    252=>"110100100"&"000000111",
    253=>"101111100"&"011001001",
    254=>"100011110"&"011001001",
    255=>"010110010"&"111101001");
    attribute rom_style : string; 
    attribute rom_style of ROM_content : signal is "block";
BEGIN
proc_name: process(clk)
begin
  if rising_edge(clk) then
    weight <= ROM_content(to_integer(address));
  end if;
end process proc_name;
END RTL;